2010-08-25  Rodrigo Kumpera  <kumpera@gmail.com>

	* MonoProperty.cs: Don't share the same field with DeclaringType
	and ReflectedType.

	in mcs/class/corlib/System:

2010-08-16  Rodrigo Kumpera  <kumpera@gmail.com>

	* MonoField.cs: Don't access ::type directly since it might be
	lazily loaded.

2010-08-16  Rodrigo Kumpera  <kumpera@gmail.com>

	* MonoField.cs (FieldType): Lazy load the field type if null.

2010-08-11  Rodrigo Kumpera  <kumpera@gmail.com>

	* CustomAttributeData.cs: This now receives only the information
	required to later load argument data. This information is stored
	in a new field that is later discarded.

	in mono/mono/metadata:

2010-07-28  Jb Evain  <jbevain@novell.com>

	* Assembly.cs: add IsFullyTrusted stub.

Thu Jul 22 11:05:04 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* Module.cs: added == and != operators for 4.0.

2010-06-21  Jb Evain  <jbevain@novell.com>

	* MonoModule.cs
	* Assembly.cs
	* MonoAssembly.cs
	* Module.cs:
		Make Assembly and Module abstract on Moonlight too.

2010-06-03  Jb Evain  <jbevain@novell.com>

	* Assembly.cs: add net_4_0's PermissionSet property.

2010-05-27  Jb Evain  <jbevain@novell.com>

	* Assembly.cs (Load*): add net_4_0 overloads.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoAssembly.cs: Fix a 2.0 corlib test failure.

2010-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* Binder.cs (SelectMethod): Exact matching must check
	all entries because if two of them match, we must use
	the slow path.

	* Binder.cs (GetBetterMethod): Don't give generic method
	definition special treatment.

	Fixes #325306.

2010-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement ResolveInternal.

2010-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoField.cs (Get|Set)Value: Check if obj is compatible
	with field's class.

2010-04-02  Marek Safar  <marek.safar@gmail.com>

	* MethodBase.cs: Made GetParameterCount abstract and implement
	where missing to avoid redundant allocations.

2010-04-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs (GetMethod): Check for null 'types' argument.

	* MonoModule.cs (GetMethodImpl): Special case when 'types'
	is null and call Type::GetMethod(string) directly.
	This is ok since proper checking of the 'types' overload
	is done by callers.

2010-04-01  Jb Evain  <jbevain@novell.com>

	* Module.cs: make Module abstract on net_4_0.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement MetadataToken, FullyQualifiedName,
	ModuleVersionId, MDStreamVersion, ScopeName,
	Name, Assembly.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement GetSignerCertificate and
	GetTypes.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement ResolveMember, ResolveMethod,
	ResolveString, ResolveType, ResolveSignature and
	GetMethods.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement GetField, GetFields,
	GetMethodImpl, GetPEKind, GetType, IsDefined and
	ResolveField.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement GetCustomAttributesData.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement GetCustomAttributes.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs:
	* MonoModule.cs: Implement FindTypes.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs: Raise the right exception.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs: Make .ctor protected under v4.
	* MonoModule.cs: Implement IsResource.

2010-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs: Make it a partial class under !v4.

	* MonoModule.cs: New type that exists only under
	v4. Under v2 it is a part of Module.

	This is the initial setup to make v4 Module an
	abstract type where all methods raise exceptions.

2010-03-30  Jb Evain  <jbevain@novell.com>

	* MonoAssembly.cs: make MonoAssembly non public.

2010-03-30  Jb Evain  <jbevain@novell.com>

	* Binder.cs (BindToMethod): fix the case where we bind to a method
	with only one params parameter and that no args are given.

2010-03-30  Jb Evain  <jbevain@novell.com>

	* Binder.cs: when invoking a params method, pack the params
	arguments before doing the actual invocation.

	Fixes #591877

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs: Add IsDynamic.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoAssembly.cs:
	* Assembly.cs: Add missing MonoTODO.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs: Add v4 ==, != and GetHashCode ()

2010-03-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs: Add v4 obsolete attribute.

2010-03-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs:
	* MonoAssembly.cs: Move a dozen methods from Assembly.cs
	to MonoAssembly.cs, so they can either be the concrete impl
	on v4 of the only impl on v2.
	Add to Assembly.cs versions that throws NotImplementedException.
	Mask Assembly.cs as abstract.

2010-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs: Make it a partial class under !v4.

	* MonoAssembly.cs: New type that exists only under
	v4. Under v2 it is a part of Assembly.

	This is the initial setup to make v4 Assembly an
	abstract type where all methods raise exceptions.

2010-03-24  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* MethodInfo.cs: Exclude IsGenericMethod* and ContainsGenericParameters
	from moonlight too.

2010-03-16  Jb Evain  <jbevain@novell.com>

	* Assembly.cs: use MOONLIGHT symbol to
	disambiguate MonoTouch and Moonlight code.

2010-03-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* EventInfo.cs: Some v4 adjustments.

2010-03-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodInfo.cs: New v4 stuff.

2010-03-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* ManifestResourceInfo.cs: New v4 .ctor.

2010-02-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* CustomAttributeData.cs:
	* ExceptionHandlingClause.cs:
	* LocalVariableInfo.cs: Add some v4 bits.

2010-02-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* PropertyInfo.cs: Small hack to avoid having cor-compare
	flagging Get(Raw)ConstantValue as not implemented.

2010-02-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodBody.cs: Add v4 bits.

2010-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodBody.cs: Add v4 bits.

2010-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodBase.cs: Add some v4 bits.

2010-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* MemberInfo.cs: Add GetCustomAttributesData.

	* Assembly.cs:
	* MemberInfo.cs:
	* Module.cs:
	* MonoEvent.cs:
	* MonoField.cs:
	* MonoMethod.cs:
	* MonoProperty.cs:
	* ParameterInfo.cs: Implement GetCustomAttributesData.

2010-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* MemberInfo.cs: Add some v4 bits.

2010-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodImplAttributes.cs: Add NoOptimization flag.

2010-02-11  Marek Habersack  <mhabersack@novell.com>

	* ConstructorInfo.cs, EventInfo.cs, FieldInfo.cs: fix 4.0 equality
	and inequality operators by casting the passed parameters to
	object. Failing to do so leads to infinite recursion calling the
	operator.

2010-02-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* FieldInfo.cs: Add some v4 bits.

2010-02-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* EventInfo.cs: Add some v4 bits.

2010-02-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* ConstructorInfo.cs: Add some v4 bits.

2010-02-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* PropertyInfo.cs: Remove a pair of MonoTODO.

	* MonoProperty.cs: Implement GetConstantValue and GetRawConstantValue.

2010-02-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoMethod.cs (GetParameters): Must return a copy instead of the interned array.

	* MonoMethod.cs (Invoke): Skip array clone in GetParameters.

	* MonoProperty.cs (GetIndexParameters): Properly handle write-only indexed properties.
	Return a ParameterInfo object bound to the properly and not to the method.

	* ParameterInfo.cs: Add new constructor that copies all fields but Member.

	* ParameterInfo.cs (MetadataToken): Properly handle tokens of non-method members.

2010-01-31  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs: Fix a warning.

2010-01-28  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* Assembly.cs: GetSatelliteAssembly: Ask LoadSatellite to not throw
	exceptions, since we ignore them anyway.

2010-01-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* ParameterInfo.cs (DefaultProperty): Fix small typo.

2010-01-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* ParameterInfo.cs (DefaultProperty): Add support for DateTime defaults.

	* ParameterInfo.cs: Implements RawDefaultProperty.

2009-12-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetMethods): When the GTD is not a typebuilder,
	calling GetMethods on it will return everything we need so no need to
	do the crazy loop.
	The returned methods might contains some that are not from a generic type
	so we need to guard against this as well.

	* MonoGenericClass.cs (GetMethodsInternal): Guard against methods that don't
	belong to a GTD as well.

2009-12-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Remove IsByRef hack.

2009-12-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (format_name): Avoid calling AssemblyQualifiedName as mcs DynamicObject
	doesn't implement it.

2009-12-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Remove useless field.

2009-12-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Change it to support a non-sre generic type
	definition.

2009-12-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Add new register_with_runtime icall to make
	sure that a managed code instantiated MGC will be returned when
	the generic instantiation happens in unmanaged code.
	
	This is a temporary workaround while Type::MakeGenericType doesn't
	handle user types properly.

2009-12-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Make this class inherit from Type instead of
	MonoType. Implement some missing methods and make sure we can still
	be used as a byref type.

2009-12-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoMethod.cs (MakeGenericMethod): If any of the arguments is
	a non system type, inflate to a MethodOnTypeBuilderInst.

2009-12-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* ParameterInfo.cs: Add constructor that takes an array of ParameterInfo
	objects.

2009-12-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement IsCompilerContext property and replace
	all checks to use it.

2009-12-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (InflateType): Add a type argument parameter and
	make this function static. Now it can inflate types using the context
	of any type.

2009-12-02  Jb Evain  <jbevain@novell.com>

	* Assembly.cs: disable warning about Assembly overriding
	Equals but not GetHashCode. That's sadly how it's in .net.

2009-12-02  Jb Evain  <jbevain@novell.com>

	* MethodInfo.cs: add an internal virtual GetBaseMethod
	returning the immediate predecessor in the inheritance chain.
	* MonoMethod.cs: modify the get_base_definition icall to take
	a boolean indicating that we want the immediate	base method
	or the original method definition and rename it to
	get_base_method. Implement GetBaseMethod with it.

2009-11-21  Miguel de Icaza  <miguel@novell.com>

	* Assembly.cs: Implement missing method.

2009-11-03  Marek Habersack  <mhabersack@novell.com>

	* Assembly.cs: GetSatelliteAssembly must catch
	AppDomain.LoadSatellite FileNotFoundException and attempt to load
	satellites from subdirectories of current assembly's
	directory. Fixes bug #548768

2009-10-30  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoMethod.cs: Remove CAS check in MonoCMethod.Invoke (just 
	like it was done for MonoMethod.Invoke sister method)

2009-10-26  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Share code between GetSatelliteAssembly and 
	GetSatelliteAssemblyNoThrow. For Moonlight ensure both 
	GetManifestResourceStream and GetSatelliteAssembly don't load
	anything "below" the assembly path.

2009-10-20  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoProperty.cs: Reduce code duplication and the number of direct
	calls to icalls (affecting the number of SecuritySafeCritical in
	Moonlight)

2009-10-19  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoEvent.cs: Reduce code duplication and the number of direct
	calls to icalls (affecting the number of SecuritySafeCritical in
	Moonlight)

2009-10-18  Sebastien Pouliot  <sebastien@ximian.com>

	* MethodBase.cs: Reduce code duplication and the number of direct
	calls to icalls (affecting the number of SecuritySafeCritical in
	Moonlight)

2009-10-17  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoMethod.cs: Reduce code duplication and the number of direct
	calls to icalls (affecting the number of SecuritySafeCritical in
	Moonlight)

2009-09-22  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Remove Evidence and GlobalAssemblyCache 
	properties for NET_2_1

2009-09-19  Sebastien Pouliot  <sebastien@ximian.com>

	* TargetException.cs, TargetInvocationException.cs,
	TargetParameterCountException.cs: Inherit from Exception for 
	NET_2_1 since ApplicationException does not exists

2009-09-18  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs, Module.cs: Avoid imperative CAS checks for NET_2_1

2009-08-18  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs: Use StringComparison.Ordinal when calling
	String.EndsWith ().

2009-08-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement almost all methods required
	to move to inherit from System.Type. The only missing methods
	are Is(Array|Pointer|ByRef)Impl and GetElementType since the
	runtime still generates weird instances for generics instances
	of non-SRE types with SRE types as generic arguments.

2009-08-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (InflateType): Add support to inflate
	generic method arguments.

	* MonoGenericClass.cs (GetMethod): Remove restriction
	with generic methods.

2009-08-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (FullName): mcs depends that FullName
	doesn't return null for instantiations over generic params
	of type builders. We special case this under compiler context.

2009-08-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Remove Is(Array|Pointer|ByRef)Impl
	and GetElementType since the runtime still produces instances
	of MonoGenericClass for those types.

2009-08-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement more methods from MonoType.
	Done with all type name related properties.

2009-08-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement Is*Impl methods to simply
	return false.

2009-08-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Implement Make(Array,ByRef,Pointer) using the
	new managed types.

2009-08-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (InflateType): Implement it in terms of managed
	code and kill the corresponding icall.

2009-08-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Add type_arguments field and constructor
	that initializes it.

2009-08-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (initialize): Remember the number
	of events available at initialization time. This is required as
	mcs expect this behavior under compiler context that new events
	are not returned for an instance that was inflated before.

	* MonoGenericClass.cs: Kill GetEvents_internal and implement it
	in terms of managed code.

2009-07-30  Zoltan Varga  <vargaz@gmail.com>

	* FieldInfo.cs: Throw an exception if internal_from_handle_type ()
	returns null. Fixes #525733.

2009-07-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (initialize): Call TypeBuilder::GetConstructorsInternal
	since the public version throws.

2008-07-29  Marek Safar  <marek.safar@gmail.com>

	* MonoGenericClass.cs: Removed one IsCompilerContext hack.

2009-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* Assembly.cs (GetType): Throw if name is empty.

2009-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* EventInfo (RemoveEventHandler): Throw InvalidOperationException if the
	event remove method is not visible.

2009-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* EventInfo (AddEventHandler): Throw TargetException if target is not cast
	compatible.

	* EventInfo (AddEventHandler): Throw InvalidOperationException if the
	event add method is not visible.

	* EventInfo (AddEventHandler): Throw TargetException if source is null
	and the event is not static.

2009-07-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetParentType): Implement using managed code.

2009-07-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Make all icalls private. Kill GetInterfaces_internal.
	Add a workaround for a GetField under compiler context.

2009-07-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetMethod): Use the new code always. Don't
	accept MethodOnTypeBuilderInst under compiler context.

	* MonoGenericClass.cs (GetField): Use the new code always.

	* MonoGenericClass.cs: Make a bunch of methods raise NotSupportedException
	when not under compiler context. Remove some dead code.

2009-07-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Kill GetConstructors_internal and implement it
	all in terms of managed code.

	* MonoGenericClass.cs: Return instances of ConstructorOnTypeBuilderInst
	under bootstrap profile.

2009-07-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Kill GetFields_internal and implement it
	all in terms of managed code.

2009-07-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Kill GetMethods_internal and implement it
	all in terms of managed code.

2009-07-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs: Kill GetProperties_internal and implement it
	all in terms of managed code.

2009-07-12  Gert Driesen  <drieseng@users.sourceforge.net>

	* Binder.cs: Only allow a type to match its byref version for
	BindToMethod (and not for SelectMethod).

2009-07-11  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Allow conversion of IntPtr to pointer types.

2009-07-10  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs (check_arguments): Allow a type to match its byref version.
	Fixes #520690.

2009-06-12  Zoltan Varga  <vargaz@gmail.com>

	* ParameterInfo.cs (DefaultValue): Add support for decimals, their default
	value is encoded using a custom attribute.

2009-05-02  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Exclude CAS-specific code for NET_2_1

2009-04-30  Sebastien Pouliot  <sebastien@ximian.com>

	* Module.cs: Exclude GetSignerCertificate (Authenticode related) 
	from NET_2_1
	* StrongNameKeyPair.cs: Adapt to work with only RSAManaged when 
	built for NET_2_1, i.e. remove use of RSACryptoServiceProvider

2009-03-26  Zoltan Varga  <vargaz@gmail.com>

	* MonoMethod.cs: Add a 'member' argument to the get_parameter_info () icall.

2009-03-03  Matthew Metnetsky  <matthew@cowarthill.com>

	* MonoMethod.cs: within Invoke only change types if BindingFlags.ExactBinding isn't set

	* MonoMethod.cs: within Invoke ensure arg types match ParameterInfo types before
	calling InvokeInternal

2009-03-20  Sebastien Pouliot  <sebastien@ximian.com>

	* EventInfo.cs, MonoProperty.cs: Ensure the delegate optimization 
	works correctly, i.e. throw the right exception, with Moonlight.

2009-03-11  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Allow conversions from T to T?. Fixes #484294.

2008-03-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* EventInfo.cs: Apply similar trick to the one in MonoProperty to speed up
	AddEventHandler.

2008-02-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoProperty.cs (GetValue): Don't use the delegate optimization for valuetypes.

2008-02-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoProperty.cs (GetValue): Optimize getters for properties without arguments.

2008-02-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoProperty.cs (GetValue): Optimize getters for properties without arguments.
	The optimization is to create a pair of chained delegates that duplicate the workings
	on MethodBase::Invoke without all the aditional overhead and without doing two
	managed/native transitions.

	Simple Getter performance is up to 17x faster.

	This patch reduces contention on domain and domain jit code hash locks, which
	can be very hot on asp.net applications.

2008-02-21  Jb Evain  <jbevain@novell.com>

	* Module.cs: add a new virtual GetModuleVersionId method,
	and make the properties .MvId and ModuleVersionId call it.
	This way, we can override it in ModuleBuilder.
	Part of the fix for #471302.

2008-02-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoMethod.cs: Fix the 1.1 build.

2008-02-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoMethod.cs (ToString): Fix the representation of non primitive structs.

2008-02-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoMethod.cs (ToString): Fix representation of pointer types.

	Fixes #409583.

2009-01-24  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs: Fix warnings.

2009-01-24 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* Assembly.cs: add new LoadSatelliteAssemblyNoThrow method and use the
	new LoadSatellite() in AppDomain.

2009-01-09  Zoltan Varga  <vargaz@gmail.com>

	* CustomAttributeData.cs (ToString): Applied patch from Leszek Ciesielski
	<skolima@gmail.com>. Use DeclaringType.FullName instead of DeclaringType.Name.
	Fixes #464830.

2008-11-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoField.cs (GetValue): Don't check for open generic types if the field
	is a constant.

2008-11-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* Module.cs (ResolveMethod): Use internal method 
	GetMethodFromHandleNoGenericCheck to avoid the generic type
	limitation of GetMethodFromHandle.

	Fixes #443763.

2008-10-02 Gonzalo Paniagua Javier <gonzalo.mono@gmail.com>

	* MonoMethod.cs: throw a MemberAccessException when
	trying to invoke a constructor creating an instance of an abstract
	class. Return null when an instance of an object was passed as a
	parameter when invoking a .ctor. Fixes bug #324185.

2008-09-07  Zoltan Varga  <vargaz@gmail.com>

	* MonoField.cs: Add check to GetValue/SetValue () to avoid crashes when it is
	called on fields of open types. Fixes #424077.

2008-08-12  Gert Driesen  <drieseng@users.sourceforge.net>

	* ReflectionSerializationHolder.cs: Removed.
	* common.src: Removed.

2008-08-04  Atsushi Enomoto  <atsushi@ximian.com>

	* Assembly.cs : return UnmanagedMemoryStream from 
	  GetManifestResourceStream(). Fixed bug #322241.

2008-07-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (InflateType): Guard against null types.
	Fixes #412965.

2008-07-23  Marek Safar  <marek.safar@gmail.com>

	* MethodBase.cs (GetMethodFromHandle): Needed for bootraping.

2008-07-22  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetMethod): Under compiler mode allow
	MethodOnTypeBuilderInst to be used..

2008-07-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetMethod): Revert to old code
	path as the new one broke System.Core.

2008-07-16  Rodrigo Kumpera  <rkumpera@novell.com>

	* MonoGenericClass.cs (GetMethod): Use the new codepath for compiler
	context.

	* MonoGenericClass.cs: New InflateType method, used to inflate
	managed types.

2008-07-11  Marek Safar  <marek.safar@gmail.com>

	* MonoGenericClass.cs (GetField): Put back removed code.

2008-07-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* MethodBase.cs (GetMethodFromHandle): Fix a warning in
	the 1.0 build.

2008-07-04  Rodrigo Kumpera  <rkumpera@n ovell.com>

	* MethodBase.cs (GetMethodFromHandle): Extract an internal version
	of this function that doesn't perform the generic class check.
	This method is required to fix the Delegate regression that fixing
	#377324 caused.

2008-06-25  Rodrigo Kumpera  <rkumpera@n ovell.com>

	* MethodBase.cs (GetMethodFromHandle): Check if the icall returns null
	and fail. This is part of the fix for #377324.

2008-06-19  Marek Safar  <marek.safar@gmail.com>

	* MonoGenericClass.cs (GetConstructor): Put back removed code due to obscure
	System.Reflection.MonoGenericCMethod.

2008-06-19  Kornel Pal  <kornelpal@gmail.com>

	* Module.cs: Add internal GetHINSTANCE.

2008-06-02  Ivan N. Zlatev  <contact@i-nz.net>

	* Binder.cs, MonoGenericClass.cs: For property reflection we should 
	strictly match the return type if available.

2008-05-16  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs (GetConstructor): Remove some old code, as the new code
	seems to work fine.
	(GetField): Ditto.

2008-05-05  Zoltan Varga  <vargaz@gmail.com>

	* FieldInfo.cs (GetFieldFromHandle): Add an argument check for an invalid handle.

	* MethodBase.cs (GetMethodFromHandle): Ditto. Fixes #386641.

2008-04-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* ParameterInfo.cs: Name must default to null if no ParameterBuilder
	is supplied.

2008-04-22  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs (GetMethod): Construct a MethodOnTypeBuilderInst object
	instead of using GetCorrespondingInflatedMethod. This is needed so this class can
	reflect the changes made to the builder after initialize () has been called.
	Fixes #381547 and #354759.
	(GetConstructor): Ditto.

2008-04-16  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Applied patch from Yves Bastide (doc.formatique@gmail.com). Add 
	support for converting integers to enums. Fixes #380361.

?2008-04-02  Andreas Nahr  <ClassDevelopment@A-SoftTech.com>

	* IReflect.cs
	* MethodInfo.cs: Fix parameter names

2008-03-31  Mark Probst  <mark.probst@gmail.com>

	* MonoMethod.cs: Don't do CAS security checks in Invoke for 2.1
	profile.

2008-03-25  Zoltan Varga  <vargaz@gmail.com>

	* MonoCMethod.cs (Invoke): Avoid a crash if this is called on a ctor of an open
	generic type. Fixes #373459.
	
	* MonoMethod.cs (InternalInvoke): Add an out 'exc' argument used to distinguish
	exceptions thrown by the icall from the exceptions thrown by the wrapped method.
	Fixes #373448.

2008-03-17  Marek Safar  <marek.safar@gmail.com>

	* MonoMethod.cs (ToString): Print VarArgs argument.

2008-03-14  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs (GetField): Construct a FieldOnTypeBuilderInst object
	instead of using GetCorrespondingInflatedField. This is needed so this class can
	reflect the changes made to the type builder after initialize () has been called.

	* Binder.cs (ChangeType): Add support for Char->Double/Single conversations. Fixes
	#367655.

2008-03-10  Gert Driesen  <drieseng@users.sourceforge.net>

	* Assembly.cs (GetFile): Fixed exception messages and param name.

2008-03-06  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs: Define GetManifestModule () for net 2.0 bootstrap as well.

2008-02-26  Ivan N. Zlatev  <contact@i-nz.net>

	* MonoProperty.cs: MS ignores the inherit parameter and defaults to false
	for GetCustomAttributes.
	[Fixes bugs #324472 and #322464]

2008-02-20  Zoltan Varga  <vargaz@gmail.com>

	* AssemblyName.cs (ReferenceMatchesDefinition): Add error checking and some 
	simple cases required by ikvm.

2008-02-18  Zoltan Varga  <vargaz@gmail.com>

	* CustomAttributeTypedArgument.cs (.ctor): Convert arrays into a collection of
	CustomAttributeTypedArguments to match MS.

2008-02-10  Gert Driesen  <drieseng@users.sourceforge.net>

	* Assembly.cs: Use icall for ToString/FullName. Fixes bug #318231.

2008-02-02  Gert Driesen  <drieseng@users.sourceforge.net>

	* MonoMethod.cs (MakeGenericMethod): Modified argument name to match
	MS. When one of the types is null, throw ArgumentNullException instead
	of ArgumentException.
	* MethodInfo.cs (MakeGenericMethod): Modified argument name to match
	MS.

2008-01-29  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs: Make GetTypes () virtual so it can be overriden by AssemblyBuilder.
	
	* Assembly.cs: Make GetModulesInternal () virtual so it can be overriden by
	AssemblyBuilder.

2008-01-22  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs: Make this NET 2.0 only.
	
	* MonoGenericClass.cs (Initialize): Simplify this a bit and add comments for this
	class.

2008-01-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* AssemblyName.cs: Added support for Retargetable spec in FullName.

2008-01-17  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs AssemblyFlagsAttribute.cs ICustomAttributeProvider.cs
	MemberInfo.cs FieldInfo.cs DefaultMemberAttribute.cs 
	CustomAttributeNamedArgument.cs TargetException.cs MethodInfo.cs
	IReflect.cs CustomAttributeTypedArgument.cs Module.cs: Change some parameter
	names to match MS.

2008-01-15  Jb Evain  <jbevain@novell.com>

	* MonoMethod.cs (MakeGenericMethod): check for null values
	in the types arguments. Fixes #353849.

2008-01-06  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Fix typo in setter found with Gendarme (was used in a
	single place, AppDomain, and set to true so it never caused a problem)

2008-01-04  Gert Driesen  <drieseng@users.sourceforge.net>

	* AssemblyName.cs: Fixed default value for ProcessorArchitecture to
	match MS. On 2.0 profile, return zero-length in FullName is no name
	is set, and throw a SecurityException in FullName and GetPublicKeyToken
	if a public key is set with no corresponding public key token. 
	Fixed FullName to also include PublicKeyToken spec with "null" value
	if public key is empty byte array. Fixed corlib part of bug #351057.
	In SetPublicKey, modify Flags accordingly. On the 2.0 profile, verify
	the public key when the public key token is computed.

2007-12-26  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs (GetSatelliteAssembly): Search in the assembly directory as well.
	Fixes ##345627.

2007-12-03  Zoltan Varga  <vargaz@gmail.com>

	* MonoField.cs: Implement GetRawConstantValue ().

2007-11-24  Marek Habersack  <mhabersack@novell.com>

	* CustomAttributeTypedArgument.cs: value can be null in ToString.

2007-11-16  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs (GetFiles): Include the assembly itself as the first entry.

2007-11-13  Atsushi Enomoto  <atsushi@ximian.com>

	* AssemblyName.cs : remove extraneous MonoTODO.

2007-11-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ExceptionHandlingClause.cs : implemented ToString().

2007-11-13  Atsushi Enomoto  <atsushi@ximian.com>

	* MethodBase.cs : (Invoke) removed extra interface implementation.

2007-11-13  Atsushi Enomoto  <atsushi@ximian.com>

	* StrongNameKeyPair.cs : implemented 2.0 runtime serialization stuff.

2007-11-05  Mark Probst  <mark.probst@gmail.com>

	* Binder.cs: Treat matches with different argument types as
	ambiguous, too.  Fixes #324998.

2007-11-01  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Avoid returning a method with a ParamArray attribute when a normal
	method exists. Fixes #338266.

2007-10-30  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Applied patch from Mario A Chavez <mario.chavez@gmail.com>. Add
	support for binding to methods with ParamArray attribute. Fixes #336841.

2007-10-27  Zoltan Varga  <vargaz@gmail.com>

	* MonoGenericClass.cs: Override GetPropertyImpl too.

2007-10-24  Atsushi Enomoto  <atsushi@ximian.com>

	* Assembly.cs : include ReflectionOnlyLoad() as part of 2.0
	  bootstrap build.

2007-09-23  Zoltan Varga  <vargaz@gmail.com>

	* Assembly.cs (GetManifestModule): New virtual method overridden by 
	AssemblyBuilder.

2007-09-17  Gert Driesen  <drieseng@users.sourceforge.net>

	* Assembly.cs: In GetManifestResourceStream, throw ANE with type as
	paramname when both name and type are null. Use String.Length to check
	for zero-length string.

2007-09-11  Mark Probst  <mark.probst@gmail.com>

	* MonoMethod.cs: Catch and re-throw MethodAccessException from
	InternalInvoke for CoreCLR security.

Thu Sep 6 19:49:34 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs: name is used as a cache: provide an icall to get the
	name from the runtime.

2007-08-23  Robert Jordan  <robertj@gmx.net>

	* MemberInfoSerializationHolder.cs: created from
	ReflectionSerializationHolder to match MS (fixes bug #80761).
	Add support for	fields, events, properties and generic methods.

	* MonoMethod.cs (GetObjectData): handle generic arguments.

	* MonoGenericMethod.cs: mark as [Serializable].

	* MonoProperty.cs (GetObjectData): implemented.

	* MonoField.cs: ditto.

	* MonoEvent.cs: ditto.

2007-07-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MonoMethod.cs : parameter types should be fixed as well.

2007-07-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MonoMethod.cs : ToString() did not show correct return type when
	  it is generic.

2007-07-15  Zoltan Varga  <vargaz@gmail.com>

	* FieldInfo.cs: Implement GetOptional/RequiredCustomModifiers ().

	* MethodInfo.cs: Remove an unneccesary MonoTODO.

	* Module.cs: Implement ResolveSignature.

2007-07-14  Zoltan Varga  <vargaz@gmail.com>

	* Module.cs: Implement the generic versions of the ResolveXXX methods.

2007-07-10  Zoltan Varga  <vargaz@gmail.com>

	* Module.cs: Add new internal method GetMDStreamVersion ().

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomAttributeNamedArgument.cs, CustomAttributeTypedArgument.cs:
	  added missing operator == and !=.

2007-07-04  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomAttributeNamedArgument.cs CustomAttributeTypedArgument.cs
	  CustomAttributeData.cs : implemented Equals() and GetHashCode().
	* Missing.cs : ISerializable.
	* AssemblyName.cs : ReferenceMatchesDefinition() stub.
	* Module.cs : missing method stubs with generic type/method args.
	* ExceptionHandlingClause.cs : ToString() stub.
	* MethodBase.cs TypeDelegator.cs ModuleResolveEventHandler.cs
	  TypeFilter.cs MemberFilter.cs
	  FieldInfo.cs ParameterInfo.cs MethodInfo.cs :
	  miscellaneous cosmetic API fixes.

Tue May 8 13:04:35 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* FieldInfo.cs, MethodBase.cs: implemented new GetFieldFromHandle and
	GetMethodFromHandle overloads (bug #78637).

2007-05-07  Zoltan Varga  <vargaz@gmail.com>

	* MonoMethod.cs (Invoke): Fix a warning.
	
	* MonoMethod.cs (Invoke): Don't wrap ThreadAbortException inside a 
	TargetInvocationException on the 2.0 profile. Fixes #81538.

2007-04-09  Alp Toker  <alp@atoker.com>

	* MonoMethod.cs: Use StringBuilder for the entire ToString() methods
	to reduce allocations and increase performance.

2007-04-09  Alp Toker  <alp@atoker.com>

	* MonoMethod.cs: Use StringBuilder for parms in ToString() methods.

2007-04-09  Alp Toker  <alp@atoker.com>

	* MethodBase.cs: IsGenericMethodDefinition() and IsGenericMethod()
	should return false, not throw NotSupportedException. This matches MS
	behaviour and introduces simplifications in subclasses.
	* MonoMethod.cs: MonoCMethod: Remove redundant overrides.

2007-03-05  Peter Dettman <peter.dettman@iinet.net.au>

	* Binder.cs: The patch changes Binder.Default.GetBetterMethod to
	prefer methods in subclasses if the arg types can't disambiguate
	them.

	Also fixes a typo in the CallingConventions comparison.

2007-03-01  Alp Toker  <alp@atoker.com>

	* FieldInfo.cs:
	Add GetFieldFromHandle() 2.0 overload stub (NotImplemented).

2007-03-01  Alp Toker  <alp@atoker.com>

	* MethodBase.cs: Add missing ComVisible attr.
	Add GetMethodFromHandle() 2.0 overload stub (NotImplemented).

2006-12-30  Marek Safar  <marek.safar@gmail.com>

	* MonoProperty.cs: Cache frequently used properties.

Thu Dec 14 13:50:48 CET 2006 Paolo Molaro <lupus@ximian.com>

	* *.cs: added missing Serializable attributes.

Thu Dec 14 12:52:27 CET 2006 Paolo Molaro <lupus@ximian.com>

	* MonoProperty.cs, ParameterInfo.cs, PropertyInfo.cs:
	GetRequiredCustomModifiers()/GetOptionalCustomModifiers()
	implementations.

Tue Dec 12 20:35:10 CET 2006 Paolo Molaro <lupus@ximian.com>

	* MethodBase.cs: added missing ComVisible attr.
	* MethodInfo.cs: added a few missing methods that we implement
	in derived classes.

Tue Dec 12 19:45:26 CET 2006 Paolo Molaro <lupus@ximian.com>

	* MonoEvent.cs: correctly obey the nonPublic flag in GetOtherMethods ().
	* EventInfo.cs: remove NotImpl exception from GetOtherMethods ().

2006-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* AssemblyName.cs: Revert change where filename was not converted to
	absolute path before passing it to Assembly.InternalGetAssemblyName
	as the CodeBase is not set in that case.

2006-10-17  Kornel Pal  <kornelpal@gmail.com>

	* FieldInfo.cs: Added GetRawConstantValue (). Note that throwing a
	  NotSupportedException is the proper implementation.
	* ParameterInfo.cs: Use Attributes in Is... properties on profile 2.0
	  that is expected by subclasses.

2006-10-14  Gert Driesen  <drieseng@users.sourceforge.net>

	* AssemblyName.cs: No need to convert filename to absolute path before
	passing it to Assembly.InternalGetAssemblyName. This allows our
	exception messages to be better match those of MS.

2006-09-29  Jb Evain  <jbevain@gmail.com>

	* MonoFieldInfo.cs: throw a FieldAccessException when setting a literal field.

2006-09-02  Zoltan Varga  <vargaz@gmail.com>

	* ParameterInfo.cs MethodInfo.cs MonoMethod.cs: Applied patch from 
	Peter Dettman (peter.dettman@iinet.net.au). Implement ReturnParameter
	property.

	* Binder.cs (ReorderParameters): Really fix this.
	
	* Binder.cs (ReorderParameters): Fix this method. Fixes #79120.

2006-09-01  Raja R Harinath  <rharinath@novell.com>

	* MonoMethod.cs (ToString): Update to handle change in byref type names.

2006-08-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* Assembly.cs: On 2.0 profile, throw FileNotFoundException for
	linked resources in GetManifestResourceStream when assembly is
	loaded from byte array.

2006-07-12  Zoltan Varga  <vargaz@gmail.com>

	* MonoMethod.cs (ContainsGenericParameters): Implement.
	
	* MonoMethod.cs (Invoke): Prevent invoking of open generic methods.

2006-07-09  Gert Driesen  <drieseng@users.sourceforge.net>

	* Assembly.cs: When assembly is loaded from byte array, return null
	for linked resources in GetManifestResourceStream. Fixes bug #78468.

2006-07-09  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Add back the support for BindingFlags.ExactBinding. Fixes #78592.

2006-06-30  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Comment out the ExactBinding stuff for the release as it breaks some 
	gtk# apps.

2006-06-07  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Add support for BindingFlags.ExactBinding. Fixes #78592.

2006-05-28  Gert Driesen  <drieseng@users.sourceforge.net>

	* MethodBase.cs: GetMethodBody should not throw ArgumentException for
	a method with no IL body. Fixes bug #78522.

2006-05-10  Zoltan Varga  <vargaz@gmail.com>

	* Module.cs (GetMethod): Update after the changes to Type.GetMethod ().

2006-05-08  Atsushi Enomoto  <atsushi@ximian.com>

	* Binder.cs : (Default.SelectMethod)
	  don't throw AmbiguousMatchException when one of conflicting method
	  matches weakly. Fixed bug #42547.

2006-05-08  Atsushi Enomoto  <atsushi@ximian.com>

	* Binder.cs : (Default.BindToMethod) reorder parameters based
	  on namedParameters. Fixed bug #41691.

2006-05-03  Jb Evain  <jbevain@gmail.com>

	* MonoField.cs (GetValue,SetValue): throw a TargetException
	when the field is non static and the target is null.

2006-03-12  Zoltan Varga  <vargaz@gmail.com>

	* Binder.cs: Applied patch from Ben to fix #74947.

2006-03-01  Miguel de Icaza  <miguel@novell.com>

	* Assembly.cs: Cache the AssemblyName, patch from Tambet.  This
	reduces the memory usage during remoting.

2006-02-16  Martin Baulig  <martin@ximian.com>

	* FieldInfo.cs (FieldInfo.Mono_GetGenericFieldDefinition): Removed.

2006-02-15  Martin Baulig  <martin@ximian.com>

	* MethodBase.cs (MethodBase.GetGenericMethodDefinition): Removed.
	(MethodBase.Mono_IsInflatedMethod): Removed.
	(MethodBase.HasGenericParameters): Removed.

	* MethodInfo.cs (MethodInfo.GetGenericMethodDefinition): Moved
	here from MethodBase.

	* MonoMethod.cs
	(MonoMethod.IsGenericMethodDefinition): This is now an icall.
	(MonoMethod.IsGenericMethod): Likewise.

2006-02-14  Martin Baulig  <martin@ximian.com>

	* MonoMethod.cs
	(MonoCMethod.IsGenericMethod): Override this and return false; the
	MS runtime doesn't throw an exception here.

2006-02-08  Martin Baulig  <martin@ximian.com>

	* MonoGenericClass.cs (MonoGenericClass.IsAssignableFrom):
	Override and implement this; fixes #77395.	

2006-02-07  Martin Baulig  <martin@ximian.com>

	* MonoMethod.cs
	(MonoMethod.IsGenericMethod): Only return true for "real" generic
	methods and not for arbitrary instantiated methods.
	(MonoMethod.IsGenericMethodDefinition): Only return true for
	generic method definitions, but not for instantiated generic
	methods.  This is no longer an interncall.  Fixes #77466.

2006-02-03  Zoltan Varga  <vargaz@gmail.com>

	* MethodBase.cs MonoMethod.cs: Implement IsGenericMethod property.
	Fixes #77460.

2005-12-23  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Fixed #75950. The icall has been changed to accept a 
	boolean so it can return a non-escaped code base.

2005-11-16  Atsushi Enomoto  <atsushi@ximian.com>

	* MonoMethod.cs : made MakeGenericMethod() indirect icall to
	  MakeGenericMethod_impl() and raise an error when it returns null.

2005-11-15  Zoltan Varga  <vargaz@gmail.com>

	* Module.cs: Add MDStreamVersion property.

	* Assembly.cs AssemblyNameFlags.cs FieldInfo.cs PropertyInfo.cs 
	CustomAttributeData.cs PortableExecutableKinds.cs 
	ObfuscateAssemblyAttribute.cs Module.cs ObfuscationAttribute.cs: Net 2.0 RTM
	updates.

2005-11-11  Marek Safar  <marek.safar@seznam.cz>

	* MethodBase.cs, TypeDelegator.cs: Reflect Type changes.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* FieldInfo.cs: Add an internal UMarshal property which can by
	overriden in FieldBuilder.

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* MonoMethod.cs : (ToString) add suffix " ByRef" for byref parameters.
	  Fixed bug #76541.

2005-10-04  Martin Baulig  <martin@ximian.com>

	* MonoGenericClass.cs (MonoGenericClass.GetParentType): Changed
	return type from `MonoGenericClass to `Type'.

2005-09-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* AssemblyName.cs: Add ParseName internal call, to parse
	long format assembly names. 
	
2005-09-25  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoProperty.cs: Invoke throws a SecurityException but GetValue must
	throw TargetInvocationException with the SecurityException as an inner
	exception. See CAS unit tests for System.Web.dll.

2005-09-20  Martin Baulig  <martin@ximian.com>

	* Assembly.cs: Removed some unused debugger icalls.

2005-09-17  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Remove obsolete Mvid property.

2005-09-09  Martin Baulig  <martin@ximian.com>

	Reflect latest API changes in the August CTP.

	* MethodBase.cs (MethodBase.MakeGenericMethod): Removed.

	* MethodInfo.cs (MethodInfo.MakeGenericMethod): Added here.

2005-09-08  Sebastien Pouliot  <sebastien@ximian.com>

	* AssemblyName.cs: Apply second half of Chris Micacchi's patch

2005-09-07  Miguel de Icaza  <miguel@novell.com>

	* AssemblyName.cs: Apply patch from Chris Micacchi to serialize
	the keyToken as "_PublicKeyToken".

2005-09-05  Martin Baulig  <martin@ximian.com>

	Reflect latest API changes in the August CTP.

	* GenericParameterAttributes.cs: Here.

	* MethodBase.cs (MethodBase.BindGenericParameters): Renamed to
	MakeGenericMethod().	

2005-09-05  Martin Baulig  <martin@ximian.com>

	* Assembly.cs (MonoDebugger_GetMethodToken): Don't take an
	`Assembly' argument.

2005-08-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: made GetManifestResourceInternal internal. Fixes the
	build.

2005-08-05  Gert Driesen <drieseng@users.sourceforge.net>

	* Assembly.cs: Added GetType() method in 1.1 to match MS.NET.
	* ConstructorInfo.cs: Added GetType() method in 1.1 to match
	MS.NET, implemented _ConstructorInfo.
	* EventInfo.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _EventInfo.
	* FieldInfo.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _FieldInfo.
	* MemberInfo.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _MemberInfo.
	* MethodBase.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _MethodBase.
	* MethodInfo.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _MethodInfo.
	* PropertyInfo.cs: Added GetType() method in 1.1 to match MS.NET,
	implemented _PropertyInfo.
	* TypeAttributes.cs: CustomFormatMask and CustomFormatClass should
	only be exposed in 2.0 profile.

2005-07-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* CustomAttributeTypedArgument: Return the name of the
	enum if the type is an enum in ToString ().
	
2005-06-21  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Create a copy of the evidences and add an instance of 
	PermissionRequestEvidence to it before resolution. This way the PRE
	won't be present when asking for evidences later. Removed debugging 
	code.

2005-06-13  Michal Moskal <malekith@nemerle.org>
	
	* MonoGenericClass.cs: Don't use MethodHandle in GetMethod/GetConstructor,
	since it now throws on MethodBuilders. Don't use FieldHandle in
	GetField (throws on FieldBuilder) - just use the name.

2005-06-15  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs, AssemblyName.cs, ConstructorInfo.cs, EventInfo.cs,
	FieldInfo.cs, MemberInfo.cs, MethodBase.cs, MethodInfo.cs, Module.cs,
	ParameterInfo.cs, PropertyInfo.cs: Added some missing interfaces and
	attributes that were added in 1.1 SP1 or 2.0 beta2.

2005-06-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs: null is ok for a value type. Fixes bug #75241.

2005-06-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: UnprotectedGetName is now virtual to allow for more
	initialization in AssemblyBuilder. The [Granted|Refused]PermissionSet
	now use the ResolvingPolicyLevel to support the policy 
	FullTrustAssemblies during resolution.
	* AssemblyName.cs: Return null instead of "new byte [0]" if no public
	key is available.

2005-06-09  Kamil Skalski <nazgul@nemerle.org>
	* MonoGenericClass.cs: Add overrides of Get{Method,Constructor,Field} 
	for obtaining instanciated *Info objects from non-instanciated counterparts


2005-06-09  Zoltan Varga  <vargaz@freemail.hu>

	* CustomAttributeData.cs EventInfo.cs Assembly.cs: Updates for net 2.0 beta 2.

	* *.cs: Updates for net 2.0 beta 2.

2005-06-07  Zoltan Varga  <vargaz@freemail.hu>

	* *.cs: Updates for net 2.0 beta 2.

2005-06-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* CustomAttributeData.cs: Implemented.

	* CustomAttributeDataNamedArgument.cs: Implemented.

	* CustomAttrbuteDataTypedArgument.cs: Implemented.
	
2005-06-06  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs ExceptionHandlingClause.cs: Fix build.

	* ProcessorArchitecture.cs: New file.

	* ExceptionHandlingClause.cs: Update after ExceptionHandlingClauseFlags name change.

	* *.cs: Updates for net 2.0 beta 2.

	* *.cs: Add net 2.0 ComVisibleAttribute.

2005-06-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: if the assembly is loaded from a byte array, Location
	returns "". Fixes bug #74958.

2005-06-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* AssemblyName.cs: Changes to support the creation of version
	instance from icalls. This change also helps to keep the
	AssemblyName tests running fine.
	
2005-05-26  Ben Maurer  <bmaurer@ximian.com>

	* Binder.cs: Avoid double checked locking and lock on typeof by
	doing init of the default binder in the cctor.

2005-05-25  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Avoid security checks if Assembly.Location is "".

2005-05-20  Zoltan Varga  <vargaz@freemail.hu>

	* TypeDelegator.cs: Implement some methods.
	
	* TypeDelegator.cs: Revert this as it breaks the build.

	* TypeDelegator.cs: Implement some methods.

2005-05-19  Satya Sudha K  <ksathyasudha@novell.com>
	    Raja R Harinath  <rharinath@novell.com>

	* Missing.cs (Missing.Value): Initialize.

2005-05-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Binder.cs: Use IsInstanceOfType instead of IsAssignableFrom
	since GetType() may not return the correct type if the object is
	a remoting proxy. This fixes bug #74933.

2005-05-13  Zoltan Varga  <vargaz@freemail.hu>

	* MonoField.cs: Applied patch from Opened by Michael Meeks (michael@ximian.com). Improve exception message on binding failures.

2005-05-09  Lluis Sanchez Gual  <lluis@novell.com>

	* MonoField.cs: Added a Clone method. This is needed for serialization.

2005-05-07  Ben Maurer  <bmaurer@ximian.com>

	* MonoEvent.cs (Get*Method): Handle nonPublic. Fixes #64191.

2005-05-06  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Update for beta 2.

	* CustomAttributeData.cs MethodBody.cs: Remove CLSCompliant (false) attributes.

2004-05-03  Lluis Sanchez  <lluis@ximian.com>

	* Assembly.cs: Don't remove version and culture information from
	the name, since it will be used by load_with_partial_name.

2005-04-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Added some CAS security to avoid returning restricted
	information to partially truster callers (e.g. code base). Added new
	methods to get the Evidence and AssemblyName so that the security
	runtime can bootstrap itself (without calling itself).

2005-04-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Added missing null check in GetObjectData.

2005-04-04  Sebastien Pouliot  <sebastien@ximian.com>

	* AssemblyName.cs: Added a demand for SerializationFormatter on
	GetObjectData method.

2005-04-04  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* AssemblyName.cs: Implemented EscapedCodeBase using the copy of 
	System.Uri (System.dll) located in Mono.Security.Uri. Added missing
	null check in GetObjectData.
	* Module.cs: Added a FileIOPermission for PathDiscovery on 
	FullyQualifiedName property (but not on Name property like MS).
	Added missing null check in GetObjectData.
	* StrongNameKeyPair.cs: Added demands for unmanaged code to all
	constructors (as we do not want partially trusted code to create
	strongnamed assemblies).

2005-03-30  Zoltan Varga  <vargaz@freemail.hu>

	* Binder.cs (check_type): Fix byref support. Fixes #73972.

2005-03-24  Sebastien Pouliot  <sebastien@ximian.com>

	* MemberInfo.cs: Add an InheritanceDemand for Unrestricted on class.
	* Module.cs: Add a LinkDemand for SerializationFormatter on 
	GetObjectData method.

2005-03-16  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Implemented EscapedCodeBase using the copy of 
	System.Uri (System.dll) located in Mono.Security.Uri. Fix bug #73663.

2005-03-11  Sebastien Pouliot  <sebastien@ximian.com>

	* MonoMethod.cs: Promote a LinkDemand (if present) to a full Demand 
	(i.e. stack walk) when reflection is being used to invoke a method.

2005-02-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Assembly.cs: LoadFrom: Change signature to support reflection only
	methods; ReflectionOnlyLoad, ReflectionOnlyLoadFrom 2.0 methods
	implemented; InvalidOperationException's re-thrown by CreateInstance.
	Also ReflectionOnly 2.0 property added.

	* MonoMethod.cs: InvalidOperationException's are re-thrown when calling 
	Invoke method on reflection only assemblies.
	
2005-02-22  Raja R Harinath  <rharinath@novell.com>

	* FieldInfo.cs (GetFieldOffset): Make 'virtual' rather than
	'abstract' so that this class can be derived outside of corlib.

2005-02-16  Miguel de Icaza  <miguel@novell.com>

	* MonoEvent.cs: Put new methods here.

	* EventInfo.cs: Move the methods GetCustomAttributes, and
	IsDefined from EventInfo to MonoEvent.

	Remove the methods that were not supposed to be exposed: Name,
	ReflectedType, DeclaringType.

2005-02-12  Chris Toshok  <toshok@ximian.com>

	* Assembly.cs: Correct the type of MonoDebugger_MakeArrayType.

2005-02-12  Ben Maurer  <bmaurer@ximian.com>

	* Binder.cs (SelectProperty): Use -1 as the dummy `I don't know
	how many types' value.

2005-02-11  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Fix warning.

2005-02-10  Martin Baulig  <martin@ximian.com>

	* Module.cs (MonoDebugger_ResolveType): New internal method.

	* Assembly.cs (MonoDebugger_MakeArrayType): New internal method.
	(MonoDebugger_GetTypeToken): New internal method.

2005-02-10  Martin Baulig  <martin@ximian.com>

	* Assembly.cs (MonoDebugger_GetMethodIndex): New internal method.

2005-02-10  Marek Safar  <marek.safar@seznam.cz>

	* Assembly.cs,
	* ConstructorInfo.cs,
	* EventInfo.cs,
	* FieldInfo.cs,
	* MemberInfo.cs,
	* MethodBase.cs,
	* MethodInfo.cs,
	* PropertyInfo.cs: ClassInterfaceType is None.

Thu Feb 3 15:22:55 CET 2005 Paolo Molaro <lupus@ximian.com>

	* Module.cs: removed the finalizer and the now unused Close() icall.

2005-01-21  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Fixed add for ModuleResolve.

2005-01-19  Zoltan Varga  <vargaz@freemail.hu>

	* LocalVariableInfo.cs: Add ToString method.

	* ExceptionHandlingClause.cs: Implement this.

2005-01-18  Zoltan Varga  <vargaz@freemail.hu>

	* MethodBase.cs MonoMethod.cs: Hopefully fix the build.

	* MethodBase.cs MonoMethod.cs: Implement 2.0 GetMethodBody ().

2005-01-03  Martin Baulig  <martin@ximian.com>

	* MonoGenericMethod.cs
	(MonoGenericMethod.get_reflected_type): Removed.
	(MonoGenericMethod.ReflectedType): Make this an icall.
	(MonoGenericCMethod.ReflectedType): Likewise.	

2004-12-29  Martin Baulig  <martin@ximian.com>

	* MonoGenericMethod.cs: New file.

2004-12-21  Sebastien Pouliot  <sebastien@ximian.com> 

	* Assembly.cs: Added private LoadAssemblyPermissions to get the 
	declarative security permission sets (minimum, optional and refused)
	for the assembly.

2004-12-20  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Removed old Demand support (moved in System.Security).

2004-12-16  Zoltan Varga  <vargaz@freemail.hu>

	* CustomAttributeData.cs MethodBody.cs: Reenable some 2.0 code now that
	the gmcs bugs blocking them are fixed.

2004-12-08  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Move corlib_internal field to AssemblyBuilder.

2004-12-06  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Add corlib_internal field.

2004-11-30  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs: Renamed to MonoGenericClass.cs and also
	renamed the class from `MonoGenericInst' to `MonoGenericClass'.

2004-11-05  Zoltan Varga  <vargaz@freemail.hu>

	* AssemblyName.cs (FullName): Omit default values from full name.

	* Assembly.cs: Implement GetFiles (bool).

	* Binder.cs: Add support for byref types. Fixes #69140.

2004-10-12  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst): Call initialize() just
	before calling the *_internal() methods.

2004-10-12  Zoltan Varga  <vargaz@freemail.hu>

	* MethodBody.cs: Implement this.

2004-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Handle the case when the global type does not exists.

2004-10-03  Zoltan Varga  <vargaz@freemail.hu>

	* LocalVariableInfo.cs: Reorganize fields so LocalBuilder can inherit
	from this class.

2004-09-28  Zoltan Varga  <vargaz@freemail.hu>

	* PropertyInfo.cs (OptionalCustomModifiers): Add [MonoTODO].

	* PropertyInfo.cs: Add stub for GetConstantValue ().	

	* ParameterInfo.cs (marshalAs): Make this private.

	* Module.cs (ModuleHandle): Add [CLSCompliant(false)].

	* LocalVariableInfo.cs MethodBody.cs: Disable default constructor.

	* ExceptionHandlingClause.cs: Disable default constructor.

2004-09-27  Zoltan Varga  <vargaz@freemail.hu>

	* CustomAttributeData.cs CustomAttributeTypedArgument.cs 
	CustomAttributeNamedArgument.cs: New files.

	* MethodBody.cs LocalVariableInfo.cs ExceptionHandlingClause.cs
	ExceptionHandlingClauseFlags.cs: New files.

2004-09-26  Zoltan Varga  <vargaz@freemail.hu>

	* FieldInfo.cs: Add support for returning MarshalAsAttribute.

	* ParameterInfo.cs: Add marshalAs field, add support for returning
	MarshalAsAttribute.

2004-09-25  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Add new 2.0 GetMethods and GetFields methods.

	* ParameterInfo.cs: Add GetPseudoCustomAttributes () method.

2004-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* MonoField.cs: Add GetFieldOffset.

	* ObfuscationAttribute.cs: Add ApplyToMembers.

	* Assembly.cs: Add stub for ReflectionOnlyLoadFrom.
	
	* Assembly.cs (LoadWithPartialName): Add [ComVisible] attribute.

	* MonoMethod.cs FieldInfo.cs: Add GetPseudoCustomAttributes () method.

	* AssemblyNameFlags.cs: Add LongevityUnspecified.

2004-09-23  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Remove [MonoTODO] from ResolveMember.

	* MemberInfo.cs: Add 'Module' property.

	* AssemblyFlagsAttribute.cs: Add 2.0 stuff.

	* Assembly.cs: Add stubs for ReflectionOnlyLoad methods. Add [Obsolete]
	to LoadWithPartialName on 2.0.

	* AssemblyNameFlags.cs: Add new 2.0 members.

	* FieldInfo.cs MonoField.cs PropertyInfo.cs ParameterInfo.cs MonoProperty.cs: Add stubs for Optinal/RequiredCustomModifiers.

	* ObfuscationAttribute.cs ObfuscateAssemblyAttribute.cs: New files.

	* EventInfo.cs: Fix 2.0 build.

	* MonoEvent.cs (MonoEventInfo): Add 'other_methods' field.

	* EventInfo.cs MonoEvent.cs: Add NET 2.0 GetOtherMethods method.

2004-09-22  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Implement net 2.0 ResolveXXX methods.

	* Module.cs (resolve_token_exception): Fix type of exception thrown.

2004-09-21  Martin Baulig  <martin@ximian.com>

	* Assembly.cs (MonoDebugger_CheckRuntimeVersion): New internal method.

2004-09-20  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Implement 2.0 reflection properties.

	* Module.cs: Implement 2.0 reflection properties. Add 'token' field.

2004-09-19  Zoltan Varga  <vargaz@freemail.hu>

	* PortableExecutableKind.cs ImageFileMachine.cs: Make this internal
	under 1.0.

	* MemberInfo.cs ParameterInfo.cs: Add MetadataToken property.

	* Module.cs: Add ModuleHandle property and new icalls.

2004-09-18  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Add net 2.0 Mvid property.

2004-08-30  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Added internal Demand(PermissionSet) for CAS.

2004-08-30  Zoltan Varga  <vargaz@freemail.hu>

	* MethodBase.cs (GetMethodFromHandle): Avoid passing a valuetype to
	icalls.

2004-08-29  Zoltan Varga  <vargaz@freemail.hu>

	* MethodBase.cs (GetMethodFromHandle): Implement.

2004-08-13  Marek Safar  <marek.safar@seznam.cz>

	* Assembly.cs: Made _minimum, _optional, _refuse fields internal.
	To be reusable by AssemblyBuilder.

2004-08-09  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Fixed some exceptions in NET_1_1 and added some 2.0
	properties (required for compiling the new unit tests).
	* PortableExecutableKind.cs: New. Flags for NET_2_0.
	* ImageFileMachine.cs: New. (Rather limited) enum for NET_2_0.

2004-08-08  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Get default evidences when no evidences have been 
	supplied. Added internal methods for CAS.
	* AssemblyName.cs: New constructor for NET_2_0.

2004-08-05  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Added new fields for CAS to match the runtime (v23).

2004-07-29  Martin Baulig  <martin@ximian.com>

	* Module.cs (Mono_GetGuid): Make this static.

Sat Jul 10 15:48:34 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* Module.cs: return just name in ToString (bug #61287).

2004-07-03  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Initialize FilterTypeName[IgnoreCase]. Fixes #61048.

2004-06-17  Gert Driesen <drieseng@users.sourceforge.net>

	* Pointer.cs: remove serializable attribute to match MS.NET

2004-06-17  Gert Driesen <drieseng@users.sourceforge.net>
	
	* ParameterModifier.cs: marked serializable, renamed field to match
	MS.NET, throw ArgumentException when parameter count is less than or
	equal to zero

2004-06-15  Gert Driesen <drieseng@users.sourceforge.net>

	* AssemblyName.cs: added TODO for serialization
	* Pointer.cs: fixed Box method to return object instead of 
	Pointer

2004-06-15  Sebastien Pouliot  <sebastien@ximian.com>

	* MemberInfo.cs: Changed constructor from internal to protected.

2004-06-11  Martin Baulig  <martin@ximian.com>

	* FieldInfo.cs (Mono_GetGenericFieldDefinition): New method for NET_2_0.

2004-06-11  Lluis Sanchez  <lluis@ximian.com>

	* StrongNameKeyPair.cs: Catch exception when getting PublicKey to match 
	  MS implementation. Generate the RSA in the constructors.

2004-06-10  Lluis Sanchez  <lluis@ximian.com>

	* AssemblyName.cs: Added missing fields to serialization methods.
	* StrongNameKeyPair.cs: Made it compatible with MS serialization.

2004-06-08  Jacson Harper  <jackson@ximian.com>

	* AssemblyName.cs (GetAssemblyName): Send a fullpath to the
	runtime. This way the codebase is set properly. The codebase is
	using g_filename_to_uri which expects a full path.
	
2004-06-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs: don't crash when we have a 'null' argument Type array.
	Allow it for non-value types. Fixed for both, methods and properties.
	Closes bug #58846.

2004-06-02  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs: default score must be lower than fail_score or we'll get
	an ambiguous match when no indexers given and one single match is found.

2004-06-02  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs: removed ^Ms. In case of several properties matching, try
	to disambiguate based on the indexer types provider and the conversions
	from those into the ones of the property.

2004-05-31  Gert Driesen <drieseng@users.sourceforge.net>

	* Assembly.cs: added missing ComVisible attribute on
	ImageRuntimeVersion property
	* ConstructorInfo.cs: added missing attributes on Invoke
	* EventInfo.cs: added missing attributes
	* FieldInfo.cs: added missing attributes
	* MethodBase.cs: added missing attributes
	* PropertyInfo.cs: added missing attributes

2004-05-22  Cesar Lopez Nataren  <cesar@ciencias.unam.mx>

	* FieldInfo.cs: changed default constructor from internal to protected, so classes
	that inherit from it can get build. 

2004-05-18  Gert Driesen (drieseng@users.sourceforge.net)

	* MonoProperty.cs: return correct MethodInfo for 
	property with only a get or set method. Fixes
	bug #58661.

2004-05-18  Sebastien Pouliot  <sebastien@ximian.com>

	* Assembly.cs: Return an empty Evidence collection to avoid 
	NullReferenceException from calling code (as this is never
	null with MS implementation). See bugzilla #53548.

2004-05-14  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Add stub for LoadFrom.

	* Assembly.cs: Fix build.

2004-05-13  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Add ModuleResolve event.

	* Module.cs (Mono_GetGuid): Make this internal.

	* FieldInfo.cs: Add stubs for {Get,Set}ValueDirect.

2004-05-13  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs: check for ambiguous matches in SelectMethod and
	SelectProperty. Fixes bug #58381.

2004-05-06  Jackson Harper <jackson@ximian.com>

	* Assembly.cs: remove TODO, this is done.
	
2004-05-06  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: ToString () returns the same as GetName ().ToString ().
	Fixes bug #58104.

2004-05-03  Jackson Harper  <jackson@ximian.com>

	* Assembly.cs: Implement LoadWithPartialName. The bulk of this
	method is done in the runtime.
	
2004-04-29  Lluis Sanchez Gual  <lluis@ximian.com>

	* MonoProperty.cs: Property.GetGetMethod() does not return the method if it
	is private (it did until now because of a bug). Make sure it works as it 
	worked before the fix.
	
2004-04-27  Lluis Sanchez Gual  <lluis@ximian.com>

	* ICustomAttributeProvider.cs, IReflect.cs, MemberInfo.cs, AssemblyName.cs: 
	  Removed completed	TODOs.
	* MonoProperty.cs: In GetAccessors(), GetGetMethod() and GetSetMethod(),
	  do not return private methods if nonPublic == false.
	* ReflectionTypeLoadException.cs: Implemented serialization support.

2004-04-26  Jackson Harper  <jackson@ximian.com>

	* Assembly.cs: Add icall to determine if an assembly has been
	loaded from the GAC.

2004-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* MethodBase.cs, MonoMethod.cs, TypeDelegator.cs :
	  The fix should be easier ;)

2004-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* MethodBase.cs, MonoMethod.cs, TypeDelegator.cs :
	  NET_2_0 related build fix.

2004-04-19  Lluis Sanchez Gual  <lluis@ximian.com>

	* Assembly.cs: Removed TODO for CreateQualifiedName.
	* AssemblyName.cs: Fixed serialization code.
	* AssemblyNameProxy.cs: Implemented.
	* Module.cs: Implemented GetMethod() methods, FindTypes() and GetObjectData.

2004-04-07  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericParam): Removed.

2004-04-07  Martin Baulig  <martin@ximian.com>

	* MethodBase.cs
	(MethodBase.GetGenericParameters): Renamed to GetGenericArguments().

	* MonoGenericInst.cs (MonoGenericInst.DeclaringType): Removed.
	(MonoGenericInst.GetNestedTypes): Just call
	`generic_type.GetNestedTypes (bf)' here.

	* MonoMethod.cs (MonoMethod.ToString): If we're a generic method,
	include the type arguments.

2004-04-06  Sebastien Pouliot  <sebastien@ximian.com>

	* StrongNameKeyPair.cs: Added support for ECMA "key". Now returns a
	correct StrongName instance when the ECMA "key" is used.

2004-04-02  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.DeclaringType): Override.

2004-04-01  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericParam.IsValueTypeImpl): Override
	this and always return false.

2004-04-01  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericParam.IsSubclassOf): Override this.	

2004-03-30  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs
	(MonoGenericParam): Added `bool	has_ctor_constraint' field.
	(MonoGenericParam.SetConstraints): Added `bool
	has_ctor_constraint' argument.	

2004-03-29  Martin Baulig  <martin@ximian.com>

	* MethodBase.cs (MethodBase.Mono_IsInflatedMethod): New public
	virtual property.
	(MethodBase.HasGenericParameters): Use the "official" behavior
	here, ie. return false if we're not a generic method.

2004-03-29  Martin Baulig  <martin@ximian.com>

	* MethodBase.cs: Moved the generics stuff here, made it virtual
	where neccessary and use the correct API.

2004-03-24  Sebastien Pouliot  <sebastien@ximian.com>

	* StrongNameKeyPair.cs: Added an internal method to return a 
	StrongName object (for AssemblyBuilder). Simplified implementation 
	using Mono.Security.Cryptography.CryptoConvert class.

2004-03-24  Zoltan Varga  <vargaz@freemail.hu>

	* AssemblyFileVersionAttribute.cs (.ctor): Add argument checking.

2004-03-23  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs: Added support for events.

2004-03-23  Martin Baulig  <martin@ximian.com>

	* MonoMethod.cs (MonoMethod.ToString): Don't include the namespace
	if it's the empty string.

2004-03-10  Martin Baulig  <martin@ximian.com>

	* MethodBase.cs (MethodBase): Implemented
	GetGenericMethodDefinition() and HasGenericParameters.

2004-03-09  Martin Baulig  <martin@ximian.com>

	* MonoEvent.cs (MonoEventInfo): Replaced `parent' with
	`declaring_type' and `reflected_type'.
	(MonoEvent): Distinguish between declaring and reflected type.

2004-02-25  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs
	(MonoGenericInst.GetNestedTypes): Override this.

2004-02-24  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs:
	(SelectProperty): check the return Type if provided.

2004-02-17  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.GetProperties): Added
	support for properties.

2004-02-17  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.GetMethods): Walk up the
	class hierarchy and return members from the parent classes.
	(GetConstructors, GetFields): Likewise.

2004-02-17  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.initialize): Don't inflate
	all the members here; we only do this for members of the current
	class and only when they're actually queried for.

2004-02-12  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoInflatedField): Removed.

	* MonoGenericInst.cs (MonoInflatedMethod, MonoInflatedCtor): Removed.

2004-02-08  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.inflate): Pass recursive
	invocations the `reflected' type as `reflected', not `this'.
	(MonoInflatedMethod, MonoInflatedCtor): Reflect latest runtime changes.

2004-02-08  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.GetParentType): New interncall.
	(MonoGenericInst.GetInterfaces_internal): New interncall.
	(MonoGenericInst): Reflect latest API changes; use GetParentType()
	and GetInterfaces_internal() instead of the fields.	

2004-02-06  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.DeclaringType): Override this.

2004-02-03  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.GetInterfaces): Override this.

2004-01-25  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs: Honor BindingFlags.DeclaredOnly.

2004-01-19  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (GetManifestResourceStream): Make the IntPtrStream keep
	a reference on the Module object which contains the resource.

	* Module.cs: Decrease the image reference count when the Module is
	garbage collected.

2004-01-16  Martin Baulig  <martin@ximian.com>

	* Assembly.cs: Make the `MonoDebugger_' methods static.

2004-01-16  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* MonoProperty.cs: changed get_property_info so that it only gets the
	values needed. Reduces the allocations needed.

2004-01-15  Martin Baulig  <martin@ximian.com>

	* Assembly.cs: Make the `MonoDebugger_' methods internal.

2004-01-04  Nick Drochak <ndrochak@gol.com>

	* Assembly.cs: Removed unused variable in catch block.Eliminates a build
	warning.

2003-12-29 Ben Maurer  <bmaurer@users.sourceforge.net>

	* MethodBase.cs: Internal method to get param count (this
	way we can get the info for the ilgen without creating
	an array, if we override the method).

2003-12-18  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Implement LoadFrom.

2003-12-17  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Add stubs for LoadFile.

2003-12-16  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (GetManifestResourceStream): Only load non-embedded
	resources from files.

2003-12-15  Zoltan Varga  <vargaz@freemail.hu>

	* MonoField.cs (SetValue): Throw an exception if the value cannot be
	converted to the field's type. Fixes #52177.

2003-12-11  Lluis Sanchez Gual <lluis@ximian.com>
	
	* AmbiguousMatchException.cs: Added serialization constructor.
	
2003-12-08  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericParam): New internal class;
	derives from MonoType.	

2003-12-08  Patrik Torstensson <p@rxc.se>

	* Binder.cs: Added internal helpers to get derived level and select the 
	most derived methodbase (used in GetMethodImpl)

2003-11-25  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (LoadWithPartialName): Return null instead of throwing
	an exception to match MS behavior.

2003-11-24  Zoltan Varga  <vargaz@freemail.hu>

	* MonoMethod.cs: Add missing constructor.

2003-11-21  Zoltan Varga  <vargaz@freemail.hu>

	* MethodBase.cs (Invoke): Make this virtual under NET 1.2.

2003-11-16  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.inflate): Call
	`parent.inflate (parent,...)' instead of
	`parent.inflate (reflected,...)'.

2003-11-16  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (InternalGetAssemblyName): New icall.

	* AssemblyName.cs (GetAssemblyName): Implement this without loading
	the assembly in question. Fixes #51035.

2003-11-14  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst): Added
	`MonoGenericInst[] interfaces' field.  This is only used for
	interface types.
	(MonoGenericInst.inflate): If we're an interface type, add the
	methods from all interfaces we inherit.

2003-11-14  Zoltan Varga  <vargaz@freemail.hu>

	* AssemblyNameFlags.cs MethodAttributes.cs: Add new enumerated values 
	from NET 1.1.
	
	* *.cs: Add missing attributes.

2003-11-11  Todd Berman  <tberman@gentoo.org>

	* AssemblyName.cs (FullName): Fixed to include a proper PublicKeyToken.

2003-11-11  Zoltan Varga  <vargaz@freemail.hu>

	* MonoMethod.cs: Implement CallingConvention member.

2003-11-10  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (InternalGetType): Add a 'module' argument so this
	method can be used from Module as well.

	* Module.cs (GetType): Implement.

	* Module.cs (GetTypes): Implement.

	* Module.cs: Remove some [MonoTODO] attributes from implemented methods.
2003-11-08  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoInflatedMethod, MonoInflatedCtor): Added
	a private `IntPtr ginst' field.
	(MonoGenericInst.IsValueTypeImpl, inflate): Allow interfaces.

2003-11-02  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.initialize): Include members
	from our parent classes in the `methods', `ctors' and `fields'
	arrays.  When inflating them, reflection now sets their
	`declaring_type' and `reflected_type' fields.
	(MonoInflatedMethod, MonoInflatedCtor): Added
	`MonoGenericInst declaring_type' and `MonoGenericInst reflected_type'
	fields and override the `DeclaringType' and `ReflectedType' properties.

2003-11-02  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoGenericInst.IsValueTypeImpl): Override this.

2003-10-31  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoInflatedField): New internal class.
	(MonoGenericInst.GetFields): Override this method and inflate
	the fields.

	* MonoField.cs: Don't make this class sealed.

2003-10-30  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs (MonoInflatedMethod, MonoInflatedCtor): New
	internal classes.

2003-10-25  Martin Baulig  <martin@ximian.com>

	* MonoGenericInst.cs: New internal class.

2003-10-18  Martin Baulig  <martin@ximian.com>

	* MethodInfo.cs (MethodInfo.GetGenericArguments): Make this method
	abstract; use an interncall in MonoMethod and a custom
	implementation in MethodBuilder.	

2003-10-17  Pedro Martinez Julia  <yoros@wanadoo.es>

	* MonoEvent.cs: implement ToString method as in MS.NET.

	* MonoMethod.cs: fix some differences between mono and MS.NET
	implementation of ToString.

2003-10-17  Zoltan Varga  <vargaz@freemail.hu>

	* AssemblyName.cs: Fix Version property when some version fields are
	undefined.

2003-10-17  Martin Baulig  <martin@ximian.com>

	* MethodInfo.cs (MethodInfo.GetGenericArguments): New method.
	(MethodInfo.BindGenericParameters): New method.

2003-10-16  Martin Baulig  <martin@ximian.com>

	* MethodInfo.cs (MethodInfo.IsGenericMethodDefinition): New
	property.	

2003-08-08  Lluis Sanchez Gual  <lluis@ximian.com>

	* ParameterInfo.cs: Modified constructor of ParameterInfo for
	  the return type of a method. Since parameter positions are
	  zero-based, the position of the return type must be is -1.

2003-08-06  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* TargetInvocationException.cs: Fixed signature

2003-07-24  Miguel de Icaza  <miguel@ximian.com>

	* TypeDelegator.cs: Added generics stubs.

2003-07-21  Lluis Sanchez Gual  <lluis@ximian.com>

	* ParameterInfo.cs: Position is zero-based in ParameterInfo.
	  Set the right position value when getting from ParameterBuilder.

Thu Jul 17 17:26:59 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* FieldInfo.cs, MonoField.cs: cleanups. Cache some info and use
	finer-grained icalls. Requires a matching runtime.

2003-07-11  Zoltan Varga  <vargaz@freemail.hu>

	* AssemblyFlagsAttribute.cs: Added new constructor from NET 1.1.

	* AssemblyFlagsAttribute.cs: Added new property from NET 1.1.

2003-07-10  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs: Implemented ImageRuntimeVersion property from NET 1.1.

Mon Jun 30 19:12:08 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* Pointer.cs: implemented.

2003-06-15  Zoltan Varga  <vargaz@freemail.hu>

	* EventInfo.cs: Implement IsSpecialName.

2003-06-10  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs (Mono_GetGuid): New method to return the GUID of the
	module.

2003-05-21  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Implement GetField and its friends.

2003-05-20  Zoltan Varga  <vargaz@freemail.hu>

	* Assembly.cs (GetManifestResourceStream): Moved handling of 
	linked resources into managed code using the newly implemented
	GetManifestResourceInfo () method.

2003-05-19  Zoltan Varga  <vargaz@freemail.hu>

	* Module.cs: Implemented IsResource.

	* Assembly.cs: Implemented GetManifestResourceInfo, GetModules,
	GetModule, GetLoadedModules methods.
	* Assembly.cs (GetManifestResourceStream): Added support for 
	resources in extern assemblies.

2003-05-13  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: fixed bug #42833.

2003-05-11  Miguel de Icaza  <miguel@ximian.com>

	* Binder.cs (ChangeType): Very simplistic change.  Am not sure if
	it is correct, but it makes RemotingCorba move along a bit more
	(Remoting.Corba invokes Binder.ConvertArgs, which calls
	Binder.ChangeType with an Attribute [] to Object []).

2003-05-10  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs:
	(check_type): fixed bug #41655.

2003-05-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: implemented GetSatelliteAssembly.

Fri Apr 11 13:06:10 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: added GetNamespaces() icall.

2003-03-17  Zoltan Varga  <vargaz@freemail.hu>

	* FieldInfo.cs (GetFieldFromHandle): Implemented.

2003-03-01  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: added missing stuff. Only ModuleResolve event is left
	out to avoid changing MonoReflectionAssembly by now.
	* ModuleResolveEventHandler.cs: delegate.

2003-02-19  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TargetInvocationException.cs: added serialization ctor.

2003-02-18  Martin Baulig  <martin@ximian.com>

	* Assembly.cs (MonoDebugger_GetMethodToken): New method to get a
	method's metadata token.

2003-02-04  Sebastien Pouliot  <spouliot@videotron.ca>

	* Module.cs: Corrected indentation for class.

2003-02-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Binder.cs:
	(check_type): return true when the target type is object and the source
	is a value type.

2003-02-03 Patrik Torstensson

	* Binder.cs: minimize locking time in DefaultBinder.

2003-02-01  Sebastien Pouliot  <spouliot@videotron.ca>

	* Module.cs: Oups - not implemented. Added MonoTODO to most methods
	so it's real status get reflected correctly on the web site.

2003-01-30  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* MonoMethod.cs: implemented GetBaseDefinition ().

2003-01-28  Patrik Torstensson
	* MonoMethod.cs: Added support for serialization for MonoMethod and MonoCMethod
	* ReflectionSerializationHolder.cs: Support class for serialization

2003-01-17  Zoltan Varga  <vargaz@freemail.hu>

	* ParameterInfo.cs: modified constructor so it allows the 
	ParameterBuilder to be null and add a 'position' argument which will
	be used when pb is null.

2003-01-16  Lluis Sanchez Gual <lsg@ctv.es>

	* Assembly.cs: added serialization support.

Sat Jan 4 18:26:41 CET 2003 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs: propagate exceptions from the internal invoke
	code that need to be propagated.

Sat Jan 4 18:04:07 CET 2003 Paolo Molaro <lupus@ximian.com>

	* Binder.cs: throw an exception if the number of arguments 
	when invoking a method is incorrect.

Thu Jan 2 19:04:58 CET 2003 Paolo Molaro <lupus@ximian.com>

	* Binder.cs: In SelectMethod() look for an exact match first.

2003-01-01  Rachel Hestilow <hestilow@ximian.com>

	* MonoField.cs (SetValue): Fix logic typo. Check that obj is
	non-null only for the non-static case.

2002-12-30  Sebastien Pouliot <spouliot@videotron.ca>

	* AssemblyName.cs: Fixed null cultureinfo in FullName (as reported by 
	Zoltan).

2002-12-23  Sebastien Pouliot <spouliot@videotron.ca>

	* AssemblyName.cs: GetPublicKey now return an empty array (not null)
	when an assembly isn't signed with a StrongName (to match MS 
	implementation) and null when no assembly is referenced. Also removed 
	commented code (no bug reported so it was probably not used).

Thu Dec 19 16:43:19 CET 2002 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs, ParameterInfo.cs: return a custom attribute
	provider for the return type of a method.

2002-12-08  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* AssemblyName.cs: little fix in FullName.

2002-12-07  Sebastien Pouliot <spouliot@videotron.ca>

	* AssemblyName.cs: Added missing methods/interfaces. Fixed some
	code to match the MS Framework.
	* StrongNameKeyPair.cs: Completed the "visible" implementation.
	There must be some internal methods to allow signing with the key.

2002-12-02  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* EventInfo.cs: implemented (Add|Remove)EventHandler.

Mon Nov 18 17:52:56 CET 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implemented GetManifestResourceStream (Type type,
	* String name).

2002-11-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: changed name of GetType (string, bool, bool) to
	InternalGetType.

2002-10-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TargetInvocationException.cs: modified default message.

2002-10-01  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* MonoProperty.cs:
	* PropertyInfo.cs: fixed bug #31535.

2002-09-27  Martin Baulig  <martin@gnome.org>

	* Assembly.cs (Assembly.GetReferencedAssemblies): Implemented.

2002-09-24  Martin Baulig  <martin@gnome.org>

	* Assembly.cs (MonoDebugger_GetType): New method to get a Type
	from its metadata token.  This should only be used by the debugger.

2002-09-21  Martin Baulig  <martin@gnome.org>

	* Assembly.cs (MonoDebugger_GetLocalTypeFromSignature): New method to
	get the type of a local variable from its signature.  This should only
	be used by the debugger.

2002-09-20  Martin Baulig  <martin@gnome.org>

	* Assembly.cs (MonoDebugger_GetMethod): New method to get a MethodBase
	from its metadata token.  This should only be used by the debugger.

Wed Sep 11 12:50:54 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Binder.cs: more default binder implementation.

	* FieldInfo.cs, MonoField.cs: fixed SetValue () implementation.
	* MonoMethod.cs: use the binder in the Invoke () implementation.
	Implemented custom attributes methods and ToString for constructors.

Thu Sep 5 20:36:27 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Binder.cs: finished the Binder class and implemented the default
	binder.

2002-09-03  Martin Baulig  <martin@gnome.org>

	* Assembly.cs (Assembly.Location): Implemented.

2002-08-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* MonoField.cs:
	(GetValue): allow obj to be null (used for static fields).

2002-08-22  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* MonoField.cs: GetValue renamed to GetValueInternal. Added check for
	null.

Wed Aug 21 13:03:25 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: GetEntryAssembly patch by Tomi Pakarinen 
	<tomi.pakarinen@welho.com>.

2002-08-20  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Assembly.cs: FullName now returns a proper string instead of
	something like 'file://...'.

	* AssemblyName.cs: added missing ToString method.

2002-08-19  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* FieldInfo.cs: implemented SetValue.

Wed Aug 14 17:37:30 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoEvent.cs, MonoMethod.cs: implemented ReflectedType.

2002-08-14  Dick Porter  <dick@ximian.com>

	* Assembly.cs: Stub out GetSatelliteAssembly

2002-08-12  Tim Coleman <tim@timcoleman.com>
	* MonoProperty.cs:
		Allow multiple parameters for GetValue ()

Thu Aug 8 13:05:44 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implemented GetFile() and GetFiles().

Mon Aug 5 21:19:41 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implemented EntryPoint and a few 
	resource related methods.

Wed Jul 24 13:08:56 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MethodBase.cs: implemented GetCurrentMethod.
	* Assembly.cs: implemented GetExecutingAssembly and
	GetCallingassembly.

Mon Jul 1 18:01:49 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoProperty.cs: handle properties with only a set method.

2002-05-24  Martin Baulig  <martin@gnome.org>

	* ParameterInfo.cs: Added internal constructor.

Thu May 23 17:18:46 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implemented CreateInstance ().

2002-05-22  Martin Baulig  <martin@gnome.org>

	* MethodBase.cs (get_next_table_index): Added `object obj' argument.

Tue May 21 12:07:40 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* EventInfo.cs: more implementation.

Mon May 20 17:37:39 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoEvent.cs: fill-in the implementation.

Sat May 4 15:00:39 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs, AssemblyName.cs: updates and fixes.

2002-04-24	Patrik Torstensson <patrik.torstensson@labs2.com>

	* MonoProperty.cs (GetValue) : basic implementation to support nunit
	* PropertyInfo.cs (GetValue) : call MonoProperty::GetValue instead of returning null

Thu Apr 18 16:40:54 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.c: cache the method name.

2002-04-12  Duncan Mak  <duncan@ximian.com>

	* AssemblyAlgorithmIdAttribute.cs: Fixed typo in AlgorithmId
	property.

	* AssemblyDelaySignAttribute.cs: Fixed type in DelaySign
	attribute.

	* AssemblyFileVersionAttribute.cs: Renamed FileVersion property to
	Version.

	* BindingFlags.cs: Added missing value "PutRefDispProperty".

	* FieldAttributes.cs: Removed value "HasSecurity".

	* ManifestResourceInfo.cs: Added missing properties FileName,
	ReferencedAssembly and ResourceLocation.

	* TargetInvocationException.cs: Added the missing constructors.

Fri Apr 12 18:32:34 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs: make Name property an icall.

2002-04-08  Nick Drochak  <ndrochak@gol.com>

	* DefaultMemberAttribute.cs: Add AttributeUsage attribute for class,
	struct and interface.

Fri Apr 5 15:40:24 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* MonoEvent.cs: remove unused code.
	* MonoProperty: implement ToString().

Wed Apr 3 17:59:26 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implement GetTypes() and GetExportedTypes().

Mon Mar 25 18:54:58 CET 2002 Paolo Molaro <lupus@ximian.com>

	* MonoEvent.cs: added the needed fields.

2002-03-20  Martin Baulig  <martin@gnome.org>

	* ConstructorInfo.cs (Invoke): Implemented, call the abstract Invoke.

	* MonoMethod.cs (MonoCMethod.Invoke): Implemented, call InternalInvoke.

2002-03-14  Dietmar Maurer  <dietmar@ximian.com>

	* MonoMethod.cs (Invoke): call InternalInvoke

	* MethodBase.cs (Invoke): call virtual invoke function 

Thu Mar 7 17:14:20 CET 2002 Paolo Molaro <lupus@ximian.com>

	* EventInfo.cs: add compiler needed methods.
	* MonoMethod.cs: make ToString() return the return type name, too.

2002-03-07  Nick Drochak  <ndrochak@gol.com>

	* BindingFlags.cs: Add missing enum values.  Thanks CorCompare.

Tue Mar 5 20:33:14 CET 2002 Paolo Molaro <lupus@ximian.com>

	* TypeAttributes.cs, MethodImplAttributes.cs: updates to latest spec.

2002-02-26  Duncan Mak  <duncan@ximian.com>

	* StrongNameKeyPair.cs: Committed for Kevin Winchester (kwin@ns.sympatico.ca>.

2002-02-24 Nick Drochak  <ndrochak@gol.com>

	* AssemblyNameFlags.cs: Use proper member name.  Thanks corcompare!

Fri Feb 22 18:54:13 CET 2002 Paolo Molaro <lupus@ximian.com>

	* MonoField.cs: implement GetValue as an internalcall.
	Implemented ToString().

Tue Feb 19 20:36:04 CET 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs, Module.cs, MonoField.cs, MonoMethod.cs,
	MonoProperty.cs, ParameterInfo.cs: Implemented custom attributes
	related methods.

Thu Feb 14 18:55:23 CET 2002 Paolo Molaro <lupus@ximian.com>

	* TypeAttributes.cs: update to latest spec.

Mon Feb 11 19:50:27 CET 2002 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: handle throwOnError in GetType() call.

2002-02-07  Duncan Mak  <duncan@ximian.com>

	* AssemblyName.cs: Implemented ISerializable interface for the
	fields that we have.

2002-02-05  Duncan Mak  <duncan@ximian.com>
	
	* Missing.cs: 
	* TargetException.cs: Added in CVS.

2002-01-31  Duncan Mak  <duncan@ximian.com>

	* ReflectionTypeLoadException.cs: Added missing bits.

2002-01-23  Duncan Mak  <duncan@ximian.com>

	* AssemblyAlgorithmIdAttribute.cs:
	* AssemblyCompanyAttribute.cs:
	* AssemblyConfigurationAttribute.cs:
	* AssemblyCopyrightAttribute.cs:
	* AssemblyCultureAttribute.cs:
	* AssemblyDefaultAliasAttribute.cs:
	* AssemblyDelaySignAttribute.cs:
	* AssemblyDescriptionAttribute.cs:
	* AssemblyFileVersionAttribute.cs:
	* AssemblyFlagsAttribute.cs:
	* AssemblyInformationalVersionAttribute.cs:
	* AssemblyKeyFileAttribute.cs:
	* AssemblyKeyNameAttribute.cs:
	* AssemblyNameProxy.cs:
	* AssemblyProductAttribute.cs:
	* AssemblyTitleAttribute.cs:
	* AssemblyTradeMarkAttribute.cs:
	* AssemblyVersionAttribute.cs:
	* CustomAttributeFormatException.cs:
	* InvalidFilterCriteriaException.cs:
	* TargetParameterCountException.cs: Added.

2002-01-23  Miguel de Icaza  <miguel@ximian.com>

	* Assembly.cs (Assembly.CodeBase): Implement.
	(Assembly.FullName): simplistic and broken implementation.  Gets
	us where we were yesterday.

	Code style fix.

Tue Jan 22 22:54:18 CET 2002 Paolo Molaro <lupus@ximian.com>

	* IReflect.cs: corrected GetMember() return type.
	* InterfaceMapping.cs, TypeDelegator.cs: implemented.

Wed Jan 9 19:37:14 CET 2002 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs: ToString () implementation.

2002-01-04  Ravi Pratap  <ravi@ximian.com>

	* Assembly.cs : Decorate missing bits with the MonoTODO
	attribute.

	* ConstructorInfo.cs, MonoMethod.cs, MonoProperty.cs, ParameterInfo.cs,
	ReflectionTypeLoadException.cs : Ditto.

	* FieldInfo.cs : Ditto.
	
Thu Jan 3 23:25:34 CET 2002 Paolo Molaro <lupus@ximian.com>
	
	* Assembly.cs: trow unimplemented exceptions.

Tue Dec 18 18:46:22 CET 2001 Paolo Molaro <lupus@ximian.com>

	* MonoMethod.cs: implemented GetParameters().
	* MonoProperty.cs: PropertyInfo implementation.
	* ParameterInfo.cs: implemented.
	* PropertyInfo.cs: fixes.

Thu Dec 13 20:18:05 CET 2001 Paolo Molaro <lupus@ximian.com>

	* FieldInfo.cs: implemented some Is* propeties.
	* MethodBase.cs: fixed attribute accessors.
	* MonoField.cs: runtime object to represent a field.
	* MonoMethod.cs: runtime object to represent a method.
	* AssemblyBuilder.cs: GetToken() methods to get tokens for
	strings, fields, methods...
	* ILGenerator.cs: handle tokens for methods.

Mon Nov 19 13:56:55 CET 2001 Paolo Molaro <lupus@ximian.com>

	* MethodBase.cs: add internal get_next_table_index() for use in
	Reflection.Emit.

Wed Nov 14 16:53:28 CET 2001 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: implement some of the Load() methods.
	* ConstructorInfo.cs: some missing stubs and fields.
	* FieldInfo.cs: IsInitOnly property.
	* ParameterInfo.cs: stubs for missing properties.
	* ParameterModifier.cs: implemented class.

2001-11-10  Sean MacIsaac  <macisaac@ximian.com>

	* Assembly.cs: Filled in some stub implementations

	* ConstructorInfo.cs: Added some stub functions for NUnit

Fri Nov 2 18:29:36 CET 2001 Paolo Molaro <lupus@ximian.com>

	* AmbiguousMatchException.cs, 
	* Assembly.cs, Module.cs: updates.
	* FieldInfo.cs: better compliance to the spec.
	* MethodBase.cs: move call_conv out of the way.
	* AssemblyBuilder.cs:  don't use internalcalls, more stuff supported.
	* FieldBuilder.cs: implemented.
	* ILGenerator.cs: implemented some opcode handling.
	* Label.cs: add constructor.
	* LocalBuilder.cs: implemented.
	* MethodBuilder.cs: don't use internalcalls, more implemented stuff.
	* ModuleBuilder.cs: don't use internalcalls, more meat here, too.
	* ParameterBuilder.cs: implemented.
	* PropertyBuilder.cs: implemented.
	* TypeBuilder.cs: don't use internalcalls, more stuff working.

Tue Sep 25 16:48:50 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* ConstructorInfo.cs, MemberFilter.cs, Module.cs: added.

Fri Sep 14 16:12:08 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* MethodBase.cs, MethodInfo.cs: added.

Thu Sep 13 18:05:16 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* Assembly.cs: added stub code.

2001-07-18  Michael Lambert <michaellambert@email.com>

	* BindingFlags.cs: Add.
